<?php
/**
 * @author    JoomlaShine.com http://www.joomlashine.com
 * @copyright Copyright (C) 2008 - 2011 JoomlaShine.com. All rights reserved.
 * @license   GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 * @version   $Id$
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted index access' );

class JSNAjax
{
	var $_template_folder_path  = '';
	var $_template_folder_name 	= '';
	var $_obj_utils				= null;
	var $_template_edition 		= '';
	var $_template_version 		= '';
	var $_template_name 		= '';
	var $_template_copyright	= '';
	var $_template_author		= '';
	var $_template_author_url	= '';
	var $_product_info_url		= '';

	function JSNAjax()
	{
		$this->_setPhysicalTmplInfo();
		require_once($this->_template_folder_path.DS.'includes'.DS.'lib'.DS.'jsn_utils.php');
		$this->_setUtilsInstance();
		$this->_setTmplInfo();
	}

	/**
	 *
	 * Initialize instance of JSNUtils class
	 */
	function _setUtilsInstance()
	{
		$this->_obj_utils = JSNUtils::getInstance();
	}

	/**
	 * Initialize Physical template information variable
	 *
	 */
	function _setPhysicalTmplInfo()
	{
		$template_name 					= explode(DS, str_replace(array('\includes\lib', '/includes/lib'), '', dirname(__FILE__)));
		$template_name 					= $template_name [count( $template_name ) - 1];
		$path_base 						= str_replace(DS."templates".DS.$template_name.DS.'includes'.DS.'lib', "", dirname(__FILE__));
		$this->_template_folder_name    = $template_name;
		$this->_template_folder_path 	= $path_base . DS . 'templates' .  DS . $template_name;
	}

	/**
	 * Initialize template information variable
	 *
	 */
	function _setTmplInfo()
	{
		$result 				 	= $this->_obj_utils->getTemplateDetails($this->_template_folder_path, $this->_template_folder_name);
		$this->_template_edition 	= $result->edition;
		$this->_template_version 	= $result->version;
		$this->_template_name 		= $result->name;
		$this->_template_copyright 	= $result->copyright;
		$this->_template_author 	= $result->author;
		$this->_template_author_url = $result->authorUrl;
		$template_name	  			= JString::strtolower($this->_template_name);
		$exploded_template_name 	= explode('_', $template_name);
		$template_name				= @$exploded_template_name[0].'-'.@$exploded_template_name[1];
		$this->_product_info_url	= JSN_TEMPLATE_INFO_URL;
	}

	/**
	 * Check cache folder writable or not
	 *
	 */
	function checkCacheFolder()
	{
		$cache_folder   = JRequest::getVar('cache_folder');
		$isDir 			= is_dir($cache_folder);
		$isWritable 	= is_writable($cache_folder);
		echo json_encode(array('isDir' => $isDir, 'isWritable' => $isWritable));
	}
	/**
	 * Check template version
	 *
	 */
	function checkVersion()
	{
		if ($this->_template_edition != '' && strtolower($this->_template_edition) != 'free')
		{
			$edition = 'pro '.strtolower($this->_template_edition);
		}
		else
		{
			$edition = 'free';
		}
		$exploded_template_name	= explode('_', JString::strtolower($this->_template_name));
		$identified_name		= 'tpl_'.@$exploded_template_name[1];
		$url 					= $this->_product_info_url.'&identified_name='.urlencode($identified_name).'&edition='.urlencode($edition);
		$obj_http_request 		= new JSNHTTPSocket($url, null, null, 'get');
		$result    		  		= $obj_http_request->socketDownload();
		if($result == false)
		{
			echo json_encode(array('connection' => false, 'version' => ''));
		}
		else
		{
			$stringDecode = json_decode($result);
			echo json_encode(array('connection' => true, 'version' => @$stringDecode->version));
		}
	}
	/**
	 * Check Files Integrity
	 *
	 */
	function checkFilesIntegrity()
	{
		require_once($this->_template_folder_path.DS.'includes'.DS.'lib'.DS.'jsn_checksum_integrity_comparison.php');
		$checksum 	= new JSNChecksumIntegrityComparison();
		$result 	= $checksum->compareIntegrity();

		if (is_array($result) && count($result) && (isset($result['added']) || isset($result['deleted']) || isset($result['modified'])))
		{
			if (count(@$result['added']) || count(@$result['deleted']) || count(@$result['modified']))
			{
				// Some files have been modified , added, or deleted
				echo json_encode(array('integrity' => 1));
			}
			else
			{
				// No files modification found
				echo json_encode(array('integrity' => 0));
			}
		}
		else
		{
			// The checksum file is missing or empty
			echo json_encode(array('integrity' => 2));
		}
	}

	function downloadSampleDataPackage()
	{
		$foldername 	= 'tmp';
		$folderpath 	= JPATH_ROOT.DS.$foldername;
		$link 			= '';
		$template_style_id	= JRequest::getInt('template_style_id', 0, 'GET');
		$obj_read_xml_file 	= new JSNReadXMLFile();
		$template_manifest	= $obj_read_xml_file->getTemplateManifestFileInformation();
		$session 			= JFactory::getSession();
		$login_identifier 	= md5('state_login_'.strtolower($template_manifest['full_name']));
		$state_login		= $session->get($login_identifier, false, 'jsntemplatesession');

		if(!$state_login) jexit('Invalid Token');

		if (is_writable($folderpath))
		{

			$joomla_version		= $this->_obj_utils->getJoomlaVersion();
			$downloadURL		= 'http://www.joomlashine.com/joomla-templates/'.strtolower(str_replace('_', '-', $template_manifest['full_name'])).'-sample-data-j'.$joomla_version.'.zip';
			$objJSNDownloadPackage = new JSNDownloadPackage($downloadURL);
			$result = $objJSNDownloadPackage->download();

			if ($result)
			{
				echo json_encode(array('download' => true, 'file_name'=> (string) $result, 'connection'=>true));
				return;
			}
			else
			{
				$msg = 'Unable to download file. Try manual installation.';
				echo json_encode(array('download' => false, 'message'=>$msg, 'redirect_link'=>$link, 'connection'=>false));
				return;
			}
		}
		else
		{
			$msg = 'Folder <strong>"/tmp"</strong> must be <strong>writable</strong> during the process.';
			echo json_encode(array('download' => false, 'message'=>$msg, 'redirect_link'=>$link, 'connection'=>true));
			return;
		}
		return;
	}

	function installSampleData()
	{
		$file_name		= JRequest::getVar('file_name');
		$foldertmp		= JPATH_ROOT.DS.'tmp';
		$folderbackup	= $this->_template_folder_path.DS.'backups';
		$link 			= '';
		$errors			= array();
		$isNotExsited	= array();

		$obj_read_xml_file 	= new JSNReadXMLFile();
		$template_manifest	= $obj_read_xml_file->getTemplateManifestFileInformation();
		$session 			= JFactory::getSession();
		$login_identifier 	= md5('state_login_'.strtolower($template_manifest['full_name']));
		//$identifier 		= md5('state_installation_'.strtolower($template_manifest['full_name']));
		$state_login		= $session->get($login_identifier, false, 'jsntemplatesession');

		if(!$state_login) jexit('Invalid Token');

		$obj_sample_data_helper			= new JSNSampleDataHelper();
		$array_non_basic_module			= $obj_sample_data_helper->getNonBasicModule();
		$array_non_basic_admin_module	= $obj_sample_data_helper->getNonBasicAdminModule();
		$array_3rd_extension_menu		= $obj_sample_data_helper->getThirdExtensionMenus();
		$domain							= $obj_sample_data_helper->getDomain();

		if (!is_writable($foldertmp))
		{
			$obj_sample_data_helper->deleteSampleDataFile($file_name);
			$msg = 'Folder <strong>"/tmp"</strong> must be <strong>writable</strong> during the process.';
			echo json_encode(array('download' => false, 'message'=>$msg, 'redirect_link'=>$link));
			return;
		}
		$path = $foldertmp.DS.$file_name;
		if (!JFile::exists($path))
		{
			$msg = JText::_('Installation file not found. Try manual installation.', true);
			echo json_encode(array('install' => false, 'message'=>$msg, 'redirect_link'=>$link, 'manual'=>true));
			return;
		}
		$unpackage = $obj_sample_data_helper->unpackPackage($file_name);

		if($unpackage)
		{
			$installed_data = $obj_read_xml_file->getSampleDataFileContent($unpackage);

			if($installed_data && is_array($installed_data))
			{
				$installed_data_information	= $obj_read_xml_file->getSampleDataFileInfomation($unpackage);

				if (trim($installed_data_information['version']) != trim($template_manifest['version']))
				{
					$obj_sample_data_helper->deleteSampleDataFile($file_name);
					$obj_sample_data_helper->deleteSampleDataFolder($unpackage);
					$msg = 'The product version you are using is outdated. <a class="link-action" href="http://www.joomlashine.com/docs/general/how-to-update-product.html" target="_blank">How to update?</a>';
					echo json_encode(array('install' => false, 'message'=>$msg, 'redirect_link'=>$link));
					return;
				}
				else
				{
					$result_check_existing_extension = $obj_sample_data_helper->checkExistingExtension($installed_data);
					foreach ($result_check_existing_extension as $key => $value)
					{
						if ($value['exist'])
						{
							$extenstion_manifest = $obj_read_xml_file->getExtensionManifestFileInformation($key, $value);
							if (count($extenstion_manifest))
							{
								if (@$extenstion_manifest['version'] != $installed_data[$key]->version)
								{
    								$errors [] = '<strong>'.$installed_data[$key]->description.'</strong> - '.'Version <strong>'.$installed_data[$key]->version.'</strong> is required. <a class="link-action" href="http://www.joomlashine.com/docs/general/how-to-update-product.html" target="_blank">How to update?</a>';
    								unset($installed_data[$key]);
								}
							}
							else
							{
								$errors [] = '<strong>'.$installed_data[$key]->description.'</strong> - '.'the version information not found in sample data package.';
								unset($installed_data[$key]);
							}
						}
						else
						{
							$errors [] = '<strong>'.$installed_data[$key]->description.'</strong> - '.'Extension is not installed. <a class="link-action" href="http://www.joomlashine.com/joomla-extensions/jsn-'.$key.'.html" target="_blank">Get it now.</a>';
							$isNotExsited [] = $key;
							unset($installed_data[$key]);
						}
					}
					$obj_backup				= JSNBackup::getInstance();
					if (is_writable($folderbackup))
					{
						$backup_file_name 		= $obj_backup->executeBackup($this->_template_folder_path.DS.'backups',$domain, $installed_data);
					}
					else
					{
						$backup_file_name		= '';
					}
					$obj_sample_data_helper->deleteNonBasicAdminModule();
					$obj_sample_data_helper->installSampleData($installed_data);
					if (count($isNotExsited))
					{
						$obj_sample_data_helper->deleteRecordAssetsTableByName($isNotExsited);
					}

					$obj_sample_data_helper->runQueryNonBasicModule($array_non_basic_module);
					$obj_sample_data_helper->runQueryNonBasicModule($array_non_basic_admin_module, true);
					$obj_sample_data_helper->restoreThirdExtensionMenus($array_3rd_extension_menu);
					$obj_sample_data_helper->rebuildMenu();
					$obj_sample_data_helper->copyContentFromFilesFolder($unpackage);
					$obj_sample_data_helper->deleteSampleDataFolder($unpackage);
					$obj_sample_data_helper->setDefaultTemplate(strtolower($template_manifest['full_name']));
					$obj_sample_data_helper->deleteSampleDataFile($file_name);

					//$session->set($identifier, true, 'jsntemplatesession');
					$session->set($login_identifier, false, 'jsntemplatesession');
					echo json_encode(array('install' => true, 'message'=>'', 'redirect_link'=>$link, 'warnings'=>$errors, 'backup_file_name'=>$backup_file_name));
					return;
				}
			}
			else
			{
				$obj_sample_data_helper->deleteSampleDataFile($file_name);
				$msg = 'Installation file not found. Try manual installation.';
				echo json_encode(array('install' => false, 'message'=>$msg, 'redirect_link'=>$link, 'manual'=>true));
				return;
			}
		}
		else
		{
			$obj_sample_data_helper->deleteSampleDataFile($file_name);
			$msg = 'Unable to extract downloaded file. Please try again.';
			echo json_encode(array('install' => false, 'message'=>$msg, 'redirect_link'=>$link));
			exit();
		}
		return;
	}

	function backupModifiedFile()
	{
		$session 			=& JFactory::getSession();
		$login_identifier 	= md5('state_update_login_'.strtolower($this->_template_name));
		$state_login		= $session->get($login_identifier, false, 'jsntemplatesession');

		if(!$state_login) jexit('Invalid Token');

		$obj_updater_helper	= new JSNUpdaterHelper();
		$backup_result 		= $obj_updater_helper->backupModifiedFile();

		if ($backup_result)
		{
			echo json_encode(array('backup' => true, 'backup_file_name'=>(is_string($backup_result))?$backup_result:''));
			exit();
		}
		else
		{
			$obj_updater_helper->destroySession();
			echo json_encode(array('backup' => false, 'backup_file_name'=>''));
			exit();
		}
	}

	function manualUpdateTemplate()
	{
		jimport('joomla.utilities.xmlelement');
		$session 					=& JFactory::getSession();
		$login_identifier 			= md5('state_update_login_'.strtolower($this->_template_name));
		$state_login				= $session->get($login_identifier, false, 'jsntemplatesession');
		$modified_file_identifier 	= md5('state_modified_file_'.strtolower($this->_template_name));
		$modified_files				= $session->get($modified_file_identifier, array(), 'jsntemplatesession');

		if(!$state_login) jexit('Invalid Token');

		$obj_updater_helper	= new JSNUpdaterHelper();
		$extract_dir 		= JRequest::getCmd('extract_dir');
		$backup_file 		= JRequest::getCmd('backup_file');

		$tmp_path 			= JPATH_ROOT.DS.'tmp';
		$extract_dir_path 	= $tmp_path.DS.$extract_dir;
		$files				= $obj_updater_helper->compareChecksumFile($extract_dir_path);
		$installer 			= JSNInstaller::getInstance();
		$strXML				= '';
		$tmpArray			= array();
		$deleted_files		= array();
		$new_manifest 		= $obj_updater_helper->findManifest($extract_dir_path);
		$tmp_new_version  	= $new_manifest->version;
		$new_version		= $tmp_new_version->data();
		$old_version		= $this->_template_version;
		$compare_version	= $this->_obj_utils->compareVersion($new_version, $old_version);

		if ($compare_version == 0)
		{
			$tmpArray = array_merge($tmpArray, $modified_files);
		}
		else
		{
			if (isset($files['added']))
			{
				$tmpArray = array_merge($tmpArray, $files['added']);
			}

			if (isset($files['modified']))
			{
				$tmpArray = array_merge($tmpArray, $files['modified']);
			}

			if (isset($files['deleted']))
			{
				$deleted_files	= $files['deleted'];
			}
		}
		$tmpArray  = array_merge($tmpArray, array('template.checksum'));
		if (count($tmpArray))
		{
			$strXML = '<?xml version="1.0" encoding="UTF-8" ?><extension><files>';
			foreach ($tmpArray as $value)
			{
				$strXML .= '<filename>'.$value.'</filename>';
			}
			foreach ($files['modified'] as $value)
			{
				$strXML .= '<filename>'.$value.'</filename>';
			}
			$strXML .= '</files></extension>';
		}

		if (!empty($strXML))
		{
			$new_tmp_xml = new JXMLElement($strXML);
		}
		else
		{
			$new_tmp_xml = null;
		}
		if (!$installer->install($extract_dir_path, $new_tmp_xml, $deleted_files))
		{
			echo json_encode(array('update' => false, 'backup_file_name'=>'', 'from_version'=>$old_version, 'to_version'=>$new_version));
		}
		else
		{
			echo json_encode(array('update' => true, 'backup_file_name'=>$backup_file, 'from_version'=>$old_version, 'to_version'=>$new_version));
		}
		$obj_updater_helper->destroySession();
		if (is_dir($extract_dir_path))
		{
			JFolder::delete($extract_dir_path);
		}
		exit();
	}

	function downloadTemplatePackage()
	{
		$session 					=& JFactory::getSession();
		$post						= JRequest::get('post');
		$login_identifier 			= md5('state_update_login_'.strtolower($this->_template_name));
		$state_login				= $session->get($login_identifier, false, 'jsntemplatesession');

		if(!$state_login) jexit('Invalid Token');

		if ($this->_template_edition != '' && $this->_template_edition != 'free')
		{
			$edition = $this->_template_edition;
		}
		else
		{
			$edition = 'free';
		}

		$tmp_path 	= JPATH_ROOT.DS.'tmp';
		if (is_writable($tmp_path))
		{
			$post['customer_password'] 	= JRequest::getString('customer_password', '', 'post', JREQUEST_ALLOWRAW);
			$obj_updater_helper	= new JSNAutoUpdaterHelper();
			$result = $obj_updater_helper->downloadTemplatePackage($post);
			if ($result)
			{
				$errorCode = strtolower((string) $result);
				switch ($errorCode)
				{
					case 'err00':
						$message = '<span class="jsn-red-message">Invalid Parameters! Can not verify your product information</span>';
						break;
					case 'err01':
						$message = '<span class="jsn-red-message">Invalid username or password. Please input JoomlaShine customer account you created when were purchasing the product</span>';
						break;
					case 'err02':
						$message = '<span class="jsn-red-message">Installation is not authorized. We could not find the product in your order list. Seems like you did not purchase it yet..</span>';
						break;
					case 'err03':
						$message = '<span class="jsn-red-message">Requested file is not found on server</span>';
						break;
					default:
						$message = '';
						break;
				}
				if ($message != '')
				{
					$obj_updater_helper->destroySession();
					echo json_encode(array('download'=>false, 'file_name'=> '', 'connection'=>true, 'message'=>$message, 'manual'=>false));
				}
				else
				{
					echo json_encode(array('download'=>true, 'file_name'=> (string) $result, 'connection'=>true, 'message'=>'', 'manual'=>false));
				}
				return;
			}
			else
			{
				if ($edition == 'free')
				{
					$msg = '<span class="jsn-red-message">Unable to download file</span>. Please try to <a href="http://www.joomlashine.com/joomla-templates/buy-jsn-tendo.html" target="_blank" class="link-action">download file from product page</a>, then select it:';
				}
				else
				{
					$msg = '<span class="jsn-red-message">Unable to download file</span>. Please try to <a href="http://www.joomlashine.com/customer-area.html" target="_blank" class="link-action">download file from Customer Area</a>, then select it:';
				}
				$obj_updater_helper->destroySession();
				echo json_encode(array('download'=>false, 'file_name'=> '', 'message'=>$msg, 'connection'=>false, 'manual'=>true));
				return;
			}
		}
		else
		{
			$msg = '<span class="jsn-red-message">Folder <strong>"/tmp"</strong> must be <strong>writable</strong> during the process.</span>';
			$obj_updater_helper->destroySession();
			echo json_encode(array('download'=>false, 'file_name'=> '', 'message'=>$msg, 'connection'=>false, 'manual'=>false));
			return;
		}
	}

	function autoUpdateTemplate()
	{
		jimport('joomla.utilities.xmlelement');
		$session 					=& JFactory::getSession();
		$login_identifier 			= md5('state_update_login_'.strtolower($this->_template_name));
		$state_login				= $session->get($login_identifier, false, 'jsntemplatesession');
		$modified_file_identifier 	= md5('state_modified_file_'.strtolower($this->_template_name));
		$modified_files				= $session->get($modified_file_identifier, array(), 'jsntemplatesession');
		$tmp_path					= JPATH_ROOT.DS.'tmp';
		if(!$state_login) jexit('Invalid Token');
		if ($this->_template_edition != '' && $this->_template_edition != 'free')
		{
			$edition = $this->_template_edition;
		}
		else
		{
			$edition = 'free';
		}

		if ($edition == 'free')
		{
			$msg_manual_download = '<span class="jsn-red-message">Unable to download file</span>. Please try to <a href="http://www.joomlashine.com/joomla-templates/buy-jsn-tendo.html" target="_blank" class="link-action">download file from product page</a>, then select it:';
		}
		else
		{
			$msg_manual_download = '<span class="jsn-red-message">Unable to download file</span>. Please try to <a href="http://www.joomlashine.com/customer-area.html" target="_blank" class="link-action">download file from Customer Area</a>, then select it:';
		}

		$package_name 				= JRequest::getCmd('package_name');
		$backup_file 				= JRequest::getCmd('backup_file');
		$package_path				= $tmp_path.DS.$package_name;
		$obj_updater_helper			= new JSNUpdaterHelper();
		$obj_auto_updater_helper	= new JSNAutoUpdaterHelper();
		$unpack 					= $obj_auto_updater_helper->unpack($package_path);
		if ($unpack)
		{
			$files			= $obj_updater_helper->compareChecksumFile($unpack['dir']);
			$installer 		= JSNInstaller::getInstance();
			$strXML				= '';
			$tmpArray			= array();
			$deleted_files		= array();
			$new_manifest 		= $obj_updater_helper->findManifest($unpack['dir']);
			$tmp_new_version  	= $new_manifest->version;
			$new_version		= $tmp_new_version->data();
			$old_version		= $this->_template_version;
			$compare_version	= $this->_obj_utils->compareVersion($new_version, $old_version);

			if ($compare_version == 0)
			{
				$tmpArray = array_merge($tmpArray, $modified_files);
			}
			else
			{
				if (isset($files['added']))
				{
					$tmpArray = array_merge($tmpArray, $files['added']);
				}

				if (isset($files['modified']))
				{
					$tmpArray = array_merge($tmpArray, $files['modified']);
				}

				if (isset($files['deleted']))
				{
					$deleted_files	= $files['deleted'];
				}
			}
			$tmpArray  = array_merge($tmpArray, array('template.checksum'));
			if (count($tmpArray))
			{
				$strXML = '<?xml version="1.0" encoding="UTF-8" ?><extension><files>';
				foreach ($tmpArray as $value)
				{
					$strXML .= '<filename>'.$value.'</filename>';
				}
				foreach ($files['modified'] as $value)
				{
					$strXML .= '<filename>'.$value.'</filename>';
				}
				$strXML .= '</files></extension>';
			}

			if (!empty($strXML))
			{
				$new_tmp_xml = new JXMLElement($strXML);
			}
			else
			{
				$new_tmp_xml = null;
			}

			if (!$installer->install($unpack['dir'], $new_tmp_xml, $deleted_files))
			{
				echo json_encode(array('update' => false, 'backup_file_name'=>'', 'message'=>$msg_manual_download, 'manual'=>true));
			}
			else
			{
				echo json_encode(array('update' => true, 'backup_file_name'=>$backup_file, 'message'=>'', 'manual'=>false));
			}
		}
		else
		{
			echo json_encode(array('update'=>false, 'backup_file_name'=>'', 'message'=>$msg_manual_download, 'manual'=>true));
		}
		$obj_updater_helper->destroySession();
		$obj_updater_helper->deleteInstallationPackage($unpack['packagefile'], $unpack['dir']);
		return;
	}
}